Imports Syncfusion.Schedule
Imports System.Data
Imports System.Data.OleDb

#Region " ScheduleAppointment class"

Public Class MDB_ScheduleItem
    Inherits ScheduleAppointment '

    Public Shared Column_AllDay As String = "AllDay"
    Public Shared Column_Content As String = "Content"
    Public Shared Column_Dirty As String = "Dirty"
    Public Shared Column_EndTime As String = "EndTime"
    Public Shared Column_IgnoreChanges As String = "IgnoreChanges"
    Public Shared Column_LabelValue As String = "LabelValue"
    Public Shared Column_LocationValue As String = "LocationValue"
    Public Shared Column_MarkerValue As String = "MarkerValue"
    Public Shared Column_Owner As String = "Owner"
    Public Shared Column_Reminder As String = "Reminder"
    Public Shared Column_ReminderValue As String = "ReminderValue"
    Public Shared Column_StartTime As String = "StartTime"
    Public Shared Column_Subject As String = "Subject"
    Public Shared Column_UniqueID As String = "ID"



    Public Sub New(ByVal dr As DataRow)
        Me.dr1 = dr
    End Sub 'New

    Private dr1 As DataRow


    Public ReadOnly Property Dr() As DataRow
        Get
            Return dr1
        End Get '     set { drv = value; }
    End Property


    Public Overrides Property AllDay() As Boolean
        Get
            Return CBool(Dr(Column_AllDay))
        End Get
        Set(ByVal value As Boolean)
            Dr(Column_AllDay) = value
        End Set
    End Property

    Public Overrides Property Content() As String
        Get
            Return CStr(Dr(Column_Content))
        End Get
        Set(ByVal value As String)
            Dr(Column_Content) = value
        End Set
    End Property

    Public Overrides Property Dirty() As Boolean
        Get
            Return Dr.RowState <> DataRowState.Unchanged ' dr[Column_Dirty];
        End Get
        Set(ByVal value As Boolean)
        End Set
    End Property '  dr[Column_Dirty] = value;

    Public Overrides Property EndTime() As DateTime
        Get
            Return CType(Dr(Column_EndTime), DateTime)
        End Get
        Set(ByVal value As DateTime)
            Dr(Column_EndTime) = value
        End Set
    End Property

    Public Overrides Property IgnoreChanges() As Boolean
        Get
            Return CBool(Dr(Column_IgnoreChanges))
        End Get
        Set(ByVal value As Boolean)
            Dr(Column_IgnoreChanges) = value
        End Set
    End Property

    Public Overrides Property LabelValue() As Integer
        Get
            Return CInt(Dr(Column_LabelValue))
        End Get
        Set(ByVal value As Integer)
            Dr(Column_LabelValue) = value
        End Set
    End Property

    Public Overrides Property LocationValue() As String
        Get
            Return FindLookupValue(MDB_ScheduleDataProvider.Locations, CInt(Dr(Column_LocationValue)))
        End Get
        Set(ByVal value As String)
            Dr(Column_LocationValue) = value
        End Set
    End Property


    Private Function FindLookupValue(ByVal list As LookUpObjectList, ByVal itemToFind As Integer) As String
        Dim val As String = ""
        Dim drv As ListObject
        For Each drv In list
            If itemToFind.Equals(drv.ValueMember) Then
                val = drv.DisplayMember
                Exit For
            End If
        Next drv
        Return val
    End Function 'FindLookupValue


    Public Overrides Property MarkerValue() As Integer
        Get
            Return CInt(Dr(Column_MarkerValue))
        End Get
        Set(ByVal value As Integer)
            Dr(Column_MarkerValue) = value
        End Set
    End Property

    Public Overrides Property Owner() As Integer
        Get
            Return CInt(Dr(Column_Owner))
        End Get
        Set(ByVal value As Integer)
            Dr(Column_Owner) = value
        End Set
    End Property

    Public Overrides Property Reminder() As Boolean
        Get
            Return CBool(Dr(Column_Reminder))
        End Get
        Set(ByVal value As Boolean)
            Dr(Column_Reminder) = value
        End Set
    End Property

    Public Overrides Property ReminderValue() As Integer
        Get
            Return CInt(Dr(Column_ReminderValue))
        End Get
        Set(ByVal value As Integer)
            Dr(Column_ReminderValue) = value
        End Set
    End Property

    Public Overrides Property StartTime() As DateTime
        Get
            Return CType(Dr(Column_StartTime), DateTime)
        End Get
        Set(ByVal value As DateTime)
            Dr(Column_StartTime) = value
        End Set
    End Property

    Public Overrides Property Subject() As String
        Get
            If Dr(Column_Subject).Equals(DBNull.Value) Then
                Return ""
            End If
            Return CStr(Dr(Column_Subject))
        End Get
        Set(ByVal value As String)
            Dr(Column_Subject) = value
        End Set
    End Property

    Public Overrides Property UniqueID() As Integer
        Get
            Return CInt(Dr(Column_UniqueID))
        End Get
        Set(ByVal value As Integer)
            Dr(Column_UniqueID) = value
        End Set
    End Property
End Class 'MDB_ScheduleItem
#End Region

#Region "ScheduleAppointmentList class"


Public Class MDB_ScheduleItemList
    Inherits ArrayListAppointmentList
    
    Public Sub New(ByVal dv As DataView)
        SetDataView(dv)
    End Sub 'New


    Protected Sub SetDataView(ByVal dv As DataView)
        Dim drv As DataRowView
        For Each drv In dv
            Me.Add(New MDB_ScheduleItem(drv.Row))
        Next drv
    End Sub 'SetDataView
End Class 'MDB_ScheduleItemList

#End Region

#Region "ScheduleDataProvider class"

Public Class MDB_ScheduleDataProvider
    Inherits ScheduleDataProvider '

    Public Shared DataSet_Name As String = "Schedule"
    Public Shared Table_Appointments As String = "Appointments"
    Public Shared Table_Markers As String = "Markers"
    Public Shared Table_Labels As String = "Labels"
    Public Shared Table_Reminders As String = "Reminders"
    Public Shared Table_Locations As String = "Locations"

    Friend Shared scheduleDataSet1 As DataSet = Nothing


    Public ReadOnly Property ScheduleDataSet() As DataSet
        Get
            Return scheduleDataSet1
        End Get '  set { scheduleDataSet = value; }
    End Property

    Private dataAdapter As OleDbDataAdapter
    Private connection As OleDbConnection
    Private connString As String

    Public Sub New(ByVal MDBpathName As String)
        MDB_ScheduleDataProvider.scheduleDataSet1 = New DataSet(DataSet_Name)

        connString = "Provider=Microsoft.JET.OLEDB.4.0;data source=" + MDBpathName

        connection = New OleDbConnection(connString)

        Dim sqlString As String = "SELECT * FROM " + Table_Markers
        dataAdapter = New OleDbDataAdapter(sqlString, connection)
        dataAdapter.Fill(ScheduleDataSet, Table_Markers)

        sqlString = "SELECT * FROM " + Table_Labels
        dataAdapter = New OleDbDataAdapter(sqlString, connection)
        dataAdapter.Fill(ScheduleDataSet, Table_Labels)

        sqlString = "SELECT * FROM " + Table_Reminders
        dataAdapter = New OleDbDataAdapter(sqlString, connection)
        dataAdapter.Fill(ScheduleDataSet, Table_Reminders)

        sqlString = "SELECT * FROM " + Table_Locations
        dataAdapter = New OleDbDataAdapter(sqlString, connection)
        dataAdapter.Fill(ScheduleDataSet, Table_Locations)

        sqlString = "SELECT * FROM " + Table_Appointments
        dataAdapter = New OleDbDataAdapter(sqlString, connection)
        dataAdapter.Fill(ScheduleDataSet, Table_Appointments)

        'close the connection and work totally disconnected
        connection.Close()
        connection.Dispose()
        connection = Nothing
    End Sub 'New



    Public Overrides Sub AddItem(ByVal item As IScheduleAppointment)
        ScheduleDataSet.Tables(Table_Appointments).Rows.Add(CType(item, MDB_ScheduleItem).Dr)
    End Sub 'AddItem
    '    base.AddItem(item);

    Public Overrides Sub CommitChanges()

        'create the connection again
        connection = New OleDbConnection(connString)
       
        Me.dataAdapter.UpdateCommand = New OleDbCommand() '

        Me.dataAdapter.UpdateCommand.Connection = Me.connection
        Me.dataAdapter.UpdateCommand.CommandText = String.Format("")
        Me.dataAdapter.UpdateCommand.CommandType = CommandType.Text
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_AllDay, OleDbType.Boolean, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_AllDay, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_Content, OleDbType.LongVarWChar, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Content, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_EndTime, OleDbType.Date, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_EndTime, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_LabelValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LabelValue, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_LocationValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LocationValue, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_MarkerValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_MarkerValue, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_Owner, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Owner, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_Reminder, OleDbType.Boolean, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Reminder, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_ReminderValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_ReminderValue, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_StartTime, OleDbType.Date, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_StartTime, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_Subject, OleDbType.LongVarWChar, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Subject, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_UniqueID, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_UniqueID, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_AllDay, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_AllDay, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_AllDay, OleDbType.Boolean, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_AllDay, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_EndTime, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_EndTime, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_EndTime, OleDbType.Date, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_EndTime, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_LabelValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LabelValue, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_LabelValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LabelValue, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_LocationValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LocationValue, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_LocationValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LocationValue, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_MarkerValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_MarkerValue, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_MarkerValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_MarkerValue, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_Owner, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Owner, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_Owner, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Owner, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_Reminder, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Reminder, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_Reminder, OleDbType.Boolean, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Reminder, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_ReminderValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_ReminderValue, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_ReminderValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_ReminderValue, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_StartTime, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_StartTime, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.UpdateCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_StartTime, OleDbType.Date, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_StartTime, DataRowVersion.Original, False, Nothing))

        Me.dataAdapter.InsertCommand = New OleDbCommand() '

        Me.dataAdapter.InsertCommand.CommandText = String.Format("INSERT INTO `{0}`(`{1}`, `{2}`, `{3}`, `{4}`, `{5}`, `{6}`, `{7}`, `{8}`, `{9}`, `{10}`, `{11}`) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", Table_Appointments, MDB_ScheduleItem.Column_AllDay, MDB_ScheduleItem.Column_Content, MDB_ScheduleItem.Column_EndTime, MDB_ScheduleItem.Column_LabelValue, MDB_ScheduleItem.Column_LocationValue, MDB_ScheduleItem.Column_MarkerValue, MDB_ScheduleItem.Column_Owner, MDB_ScheduleItem.Column_Reminder, MDB_ScheduleItem.Column_ReminderValue, MDB_ScheduleItem.Column_StartTime, MDB_ScheduleItem.Column_Subject)
        Me.dataAdapter.InsertCommand.CommandType = CommandType.Text
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_AllDay, OleDbType.Boolean, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_AllDay, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_Content, OleDbType.LongVarWChar, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Content, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_EndTime, OleDbType.Date, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_EndTime, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_LabelValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LabelValue, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_LocationValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LocationValue, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_MarkerValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_MarkerValue, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_Owner, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Owner, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_Reminder, OleDbType.Boolean, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Reminder, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_ReminderValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_ReminderValue, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_StartTime, OleDbType.Date, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_StartTime, DataRowVersion.Current, False, Nothing))
        Me.dataAdapter.InsertCommand.Parameters.Add(New OleDbParameter(MDB_ScheduleItem.Column_Subject, OleDbType.LongVarWChar, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Subject, DataRowVersion.Current, False, Nothing))

        Me.dataAdapter.InsertCommand.Connection = Me.connection


        Me.dataAdapter.DeleteCommand = New OleDbCommand() '

        Me.dataAdapter.DeleteCommand.Connection = Me.connection
        Me.dataAdapter.DeleteCommand.CommandText = ""
        Me.dataAdapter.DeleteCommand.CommandType = CommandType.Text
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_UniqueID, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_UniqueID, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_AllDay, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_AllDay, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_AllDay, OleDbType.Boolean, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_AllDay, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_EndTime, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_EndTime, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_EndTime, OleDbType.Date, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_EndTime, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_LabelValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LabelValue, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_LabelValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LabelValue, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_LocationValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LocationValue, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_LocationValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_LocationValue, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_MarkerValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_MarkerValue, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_MarkerValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_MarkerValue, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_Owner, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Owner, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_Owner, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Owner, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_Reminder, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Reminder, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_Reminder, OleDbType.Boolean, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_Reminder, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_ReminderValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_ReminderValue, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_ReminderValue, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_ReminderValue, DataRowVersion.Original, False, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("IsNull_" + MDB_ScheduleItem.Column_StartTime, OleDbType.Integer, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_StartTime, DataRowVersion.Original, True, Nothing))
        Me.dataAdapter.DeleteCommand.Parameters.Add(New OleDbParameter("Original_" + MDB_ScheduleItem.Column_StartTime, OleDbType.Date, 0, ParameterDirection.Input, CByte(0), CByte(0), MDB_ScheduleItem.Column_StartTime, DataRowVersion.Original, False, Nothing))


        Me.dataAdapter.Update(ScheduleDataSet, Table_Appointments) '

        Me.connection.Close()
    End Sub 'CommitChanges 

    Private Shared labels1 As LookUpObjectList


    Friend Shared Property Labels() As LookUpObjectList
        Get
            If labels1 Is Nothing Then
                labels1 = New LookUpObjectList(scheduleDataSet1.Tables(Table_Labels).DefaultView)
            End If
            Return MDB_ScheduleDataProvider.labels1
        End Get
        Set(ByVal value As LookUpObjectList)
            MDB_ScheduleDataProvider.labels1 = value
        End Set
    End Property

    Public Overrides Function GetLabels() As ILookUpObjectList
        Return Labels
    End Function 'GetLabels
    Private Shared locations1 As LookUpObjectList


    Friend Shared Property Locations() As LookUpObjectList
        Get
            If locations1 Is Nothing Then
                locations1 = New LookUpObjectList(scheduleDataSet1.Tables(Table_Locations).DefaultView)
            End If
            Return MDB_ScheduleDataProvider.locations1
        End Get
        Set(ByVal value As LookUpObjectList)
            MDB_ScheduleDataProvider.locations1 = value
        End Set
    End Property

    Public Overrides Function GetLocations() As ILookUpObjectList
        Return Locations
    End Function 'GetLocations
    Private Shared markers1 As LookUpObjectList


    Friend Shared Property Markers() As LookUpObjectList
        Get
            If markers1 Is Nothing Then
                markers1 = New LookUpObjectList(scheduleDataSet1.Tables(Table_Markers).DefaultView)
            End If
            Return MDB_ScheduleDataProvider.markers1
        End Get
        Set(ByVal value As LookUpObjectList)
            MDB_ScheduleDataProvider.markers1 = value
        End Set
    End Property

    Public Overrides Function GetMarkers() As ILookUpObjectList
        Return Markers
    End Function 'GetMarkers


    'not used in this sample...
    Public Overrides Function GetOwners() As IScheduleResourceList
        Return MyBase.GetOwners()
    End Function 'GetOwners

    Private Shared reminders1 As LookUpObjectList


    Friend Shared Property Reminders() As LookUpObjectList
        Get
            If reminders1 Is Nothing Then
                reminders1 = New LookUpObjectList(scheduleDataSet1.Tables(Table_Reminders).DefaultView)
            End If

            Return reminders1
        End Get
        Set(ByVal value As LookUpObjectList)
            reminders1 = value
        End Set
    End Property

    Public Overrides Function GetReminders() As ILookUpObjectList
        Return Reminders
    End Function 'GetReminders

    Public Overloads Overrides Function GetSchedule(ByVal startDate As DateTime, ByVal endDate As DateTime) As IScheduleAppointmentList
        Dim dv As New DataView(ScheduleDataSet.Tables(Table_Appointments))
        dv.RowFilter = String.Format("[{0}] >= #{1}# AND [{2}] < #{3}#", MDB_ScheduleItem.Column_StartTime, startDate.Date, MDB_ScheduleItem.Column_EndTime, endDate.Date.AddDays(1))
        Return New MDB_ScheduleItemList(dv)
    End Function 'GetSchedule
    'return base.GetSchedule(startDate, endDate);
    Public Overloads Overrides Function GetSchedule(ByVal startDate As DateTime, ByVal endDate As DateTime, ByVal owner As Integer) As IScheduleAppointmentList
        'owner not supported...
        'return base.GetSchedule(startDate, endDate, owner);
        Return GetSchedule(startDate, endDate)
    End Function 'GetSchedule

    Public Overloads Overrides Function GetScheduleForDay(ByVal day As DateTime) As IScheduleAppointmentList
        Return GetSchedule(day, day)
    End Function 'GetScheduleForDay

    Public Overloads Overrides Function GetScheduleForDay(ByVal day As DateTime, ByVal owner As Integer) As IScheduleAppointmentList
        'return base.GetScheduleForDay(day, owner);
        'owner not supported
        Return GetScheduleForDay(day)
    End Function 'GetScheduleForDay

    Public Overrides Property IsDirty() As Boolean
        Get
            Dim dt As DataTable = ScheduleDataSet.Tables(Table_Appointments).GetChanges()
            Return Not (dt Is Nothing) AndAlso dt.Rows.Count > 0
        End Get
        Set(ByVal value As Boolean)
        End Set
    End Property
    ' base.IsDirty = value;
    Public Overrides Function NewScheduleAppointment() As IScheduleAppointment
        Dim dr As DataRow = ScheduleDataSet.Tables(Table_Appointments).NewRow()

        PopulateDefaults(dr)
        Return New MDB_ScheduleItem(dr)
    End Function 'NewScheduleAppointment


    Private Sub PopulateDefaults(ByVal dr As DataRow)
        dr(MDB_ScheduleItem.Column_AllDay) = False
        dr(MDB_ScheduleItem.Column_Content) = ""
        ' dr[MDB_ScheduleItem.Column_Dirty] = false;
        dr(MDB_ScheduleItem.Column_EndTime) = DateTime.Now
        ' dr[MDB_ScheduleItem.Column_IgnoreChanges] = false;
        dr(MDB_ScheduleItem.Column_LabelValue) = 0
        dr(MDB_ScheduleItem.Column_LocationValue) = 0
        dr(MDB_ScheduleItem.Column_MarkerValue) = 0
        dr(MDB_ScheduleItem.Column_Owner) = 0
        dr(MDB_ScheduleItem.Column_Reminder) = False
        dr(MDB_ScheduleItem.Column_ReminderValue) = 0
        dr(MDB_ScheduleItem.Column_StartTime) = DateTime.Now
        dr(MDB_ScheduleItem.Column_Subject) = ""
    End Sub 'PopulateDefaults

    Public Overrides Sub RemoveItem(ByVal item As IScheduleAppointment)
        CType(item, MDB_ScheduleItem).Dr.Delete()
    End Sub 'RemoveItem

    Public Overrides Sub SaveModifiedItem(ByVal appModifiedItem As IScheduleAppointment, ByVal appOriginalItem As IScheduleAppointment)

        CType(appOriginalItem, MDB_ScheduleItem).Dr.ItemArray = CType(appModifiedItem, MDB_ScheduleItem).Dr.ItemArray.Clone()

        '       (appOriginalItem as MDB_ScheduleItem).Dr.ItemArray = (appModifiedItem as MDB_ScheduleItem).Dr.ItemArray.Clone() as object[];

    End Sub 'SaveModifiedItem
End Class 'MDB_ScheduleDataProvider

#End Region

#Region "Lookup list support"


Public Class LookUpObjectList
    Inherits ListObjectList

    Public Sub New(ByVal dv As DataView)
        Dim drv As DataRowView
        For Each drv In dv
            Me.Add(New LookUpObject(drv))
        Next drv
    End Sub 'New
End Class 'LookUpObjectList
    _

Public Class LookUpObject
    Inherits ListObject
    Public Shared Column_ID As String = "ID"
    Public Shared Column_ColorRed As String = "ColorRed"
    Public Shared Column_ColorBlue As String = "ColorBlue"
    Public Shared Column_ColorGreen As String = "ColorGreen"
    Public Shared Column_Display As String = "Display"

    Private drv As DataRowView

    Public Sub New(ByVal drv As DataRowView)
        MyBase.New(CInt(drv(Column_ID)), drv(Column_Display).ToString(), Color.FromArgb(CInt(drv(Column_ColorRed)), CInt(drv(Column_ColorBlue)), CInt(drv(Column_ColorGreen))))
        Me.drv = drv
    End Sub 'New


    Public Overrides Property ColorMember() As Color
        Get
            Return Color.FromArgb(CInt(drv(Column_ColorRed)), CInt(drv(Column_ColorBlue)), CInt(drv(Column_ColorGreen)))
        End Get
        Set(ByVal value As Color)
            drv(Column_ColorRed) = value.R
            drv(Column_ColorBlue) = value.B
            drv(Column_ColorGreen) = value.G
        End Set
    End Property


    Public Overrides Property DisplayMember() As String
        Get
            Return drv(Column_Display).ToString()
        End Get
        Set(ByVal value As String)
            drv(Column_Display) = value
        End Set
    End Property


    Public Overrides Property ValueMember() As Integer
        Get
            Return CInt(drv(Column_ID))
        End Get
        Set(ByVal value As Integer)
            drv(Column_ID) = value
        End Set
    End Property
End Class 'LookUpObject
#End Region
